package org.purl.jh.esslli.data;

import java.util.Arrays;
import java.util.List;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author j
 */
public class TailChangeRuleTest {
    
    public TailChangeRuleTest() {
    }

    
    @Test
    public void testFromSpecString() {
        testFromSpecString("a>b", Arrays.asList("a"), Arrays.asList("b"), Arrays.asList(false));
        testFromSpecString("a?b", Arrays.asList("a"), Arrays.asList("b"), Arrays.asList(true));

        testFromSpecString("aa>bb", Arrays.asList("aa"), Arrays.asList("bb"), Arrays.asList(false));
        testFromSpecString("aa?bb", Arrays.asList("aa"), Arrays.asList("bb"), Arrays.asList(true));

        testFromSpecString("a>", Arrays.asList("a"), Arrays.asList(""), Arrays.asList(false));
        testFromSpecString("a?", Arrays.asList("a"), Arrays.asList(""), Arrays.asList(true));

        testFromSpecString(">b", Arrays.asList(""), Arrays.asList("b"), Arrays.asList(false));
        testFromSpecString("?b", Arrays.asList(""), Arrays.asList("b"), Arrays.asList(true));

        testFromSpecString("a>b:c?d:e>f", Arrays.asList("a", "c", "e"), Arrays.asList("b", "d", "f"), Arrays.asList(false, true, false));
    }

    public void testFromSpecString(String spec, List<String> oldTails, List<String> newTails, List<Boolean> opts) {
        TailChangeRule r = TailChangeRule.fromSpecString(spec);
        assertEquals(r.getOldTails(), oldTails);
        assertEquals(r.getNewTails(), newTails);
        assertEquals(r.getOpt(), opts);
    }    
    
    
    @Test
    public void testApply() {
        
    }

    @Test
    public void testReplaceTail() {
        assertEquals("abcd", TailChangeRule.replaceTail("abc", "", "d"));
        assertEquals("abcd", TailChangeRule.replaceTail("abcde", "e", ""));

        assertEquals("x", TailChangeRule.replaceTail("abcd", "abcd", "x"));
        assertEquals("", TailChangeRule.replaceTail("abcd", "abcd", ""));
        
        assertEquals("abcd", TailChangeRule.replaceTail("abcD", "D", "d"));
        assertEquals("abcd", TailChangeRule.replaceTail("abcDE", "DE", "d"));
        assertEquals("abcde", TailChangeRule.replaceTail("abcDE", "DE", "de"));

    }
}